----------------------------------------------------------------
-- Barret reducer (barret_reducer.adb)
-- 
-- Computes X mod M using Barret algorithm
----------------------------------------------------------------
with Gnat.Io; use Gnat.Io;
with finite_fields; use finite_fields;
procedure Barrett_reducer is 
   B, t, c, x, y, w, m, r, q, z: natural;
begin
   Put("B = "); Get(B);
   if B = 2 then t := 2; else t := 1; end if;
   Put("m = "); Get(m);
   c := (B**n)/m;
   loop
     Put("x = "); Get(x);    
     ---------------------------------------------------------------------
     y := x/B**(k-1); w := y*c; q := (w/B**(n-k+1)) mod B**(k+t);
     r := ((x mod B**(k+t)) - ((q*m) mod B**(k+t))) mod B**(k+t);
     --New_Line; Put("(y = "); put(y); Put("; w = "); put(w); 
     --Put("; q = "); put(q); Put("; r = "); put(r); Put(" )");New_Line;
     while r >= m loop r := r-m; end loop;
     z := r;
     ---------------------------------------------------------------------
     Put(x); Put(" mod "); Put(m); Put(" = "); Put(z); New_Line; New_Line;
end loop;
end Barrett_reducer;





