----------------------------------------------------------------
-- non-restoring reducer (nr_reducer.adb)
-- 
-- Computes X mod M
----------------------------------------------------------------
with Gnat.Io; use Gnat.Io;
with finite_fields; use finite_fields;
procedure nr_reducer is

function quotient(s: in integer; y: in natural) return integer is
begin
if s < 0 then return -1; else return 1; end if;
end quotient;

x, m, y, s, r, z: integer;

begin
loop
Put("m = "); Get(m);   
Put("x = "); Get(x);    
----------------------------------------------------------------------
y := m*(2**(n-k));
s := x;
for i in 0 .. n-k loop
   if quotient(s,y) = 1 then r := s - y;
   elsif quotient(s,y) = 0 then r := s;
   else r := s + y;
   end if;
   s := 2*r;
end loop;
z := r / (2**(n-k));
if z < 0 then z := (z + m); end if;
---------------------------------------------------------------------------
Put(x); Put(" mod "); Put(m); Put(" = "); Put(z); New_Line; New_Line;
end loop;
end nr_reducer;





