----------------------------------------------------------------
-- 2**K-a reducer (two_power_k_minus_a_reducer.adb)
-- use "finite_field.ads"
-- 
-- Computes X mod M
----------------------------------------------------------------

with Gnat.Io; use Gnat.Io;
with finite_fields; use finite_fields;
procedure two_power_k_minus_a_reducer is

s: integer:= 1; -- in order to show the iterations
x, m, q, r, a, z: integer;

begin
loop
Put("m = "); Get(m);   
Put("x = "); Get(x);    
----------------------------------------------------------------------
r := x mod 2**k; 
q := x/2**k; 
a := 2**k - m;
loop --
  Put("Loop: "); Put(s);Put(" - Start  q: "); Put(q); Put(" r: "); Put(r);
  loop -- main loop
    r := r + (q*a mod 2**k); 
    q := q*a/2**k; 
    if q = 0 then exit; end if;
  end loop;
  Put(" -> End  - q: "); Put(q); Put(" r: "); Put(r);New_Line; s := s+1;
  q := r/2**k; r := r mod 2**k;
  if q = 0 then exit; end if;
end loop;   
--z := r;
if r >= m then z := r-m; else z := r; end if;

---------------------------------------------------------------------------
Put(x); Put(" mod "); Put(m); Put(" = "); Put(z); Put(" mod "); Put(m); New_Line; New_Line;
end loop;
end two_power_k_minus_a_reducer;





