----------------------------------------------------------------
-- Finite Field reducer package (finite_fields.ads)
--
-- For examples of Chapter 2
----------------------------------------------------------------
package finite_fields is
   subtype Bit is Natural range 0 .. 1;
   type bit_vector is array (natural range <>) of bit;
   n: constant natural := 20;
   k: constant natural :=8;
   s: constant natural := 3; --s = rounded(n/k)
   logn: constant := 5;
   subtype Digit is Natural range 0 .. 2**K - 1;
   type Digit_Vector is array (0 .. S-1) of Digit;
   function b_table(m: digit) return digit_vector;
end finite_fields;

