----------------------------------------------------------------
-- Precomputation reducer (precomputation_reducer.adb)
-- use "finite_fields.ads"
--
-- Computes X mod M
----------------------------------------------------------------
with Gnat.Io; use Gnat.Io;
with finite_fields; use finite_fields;
procedure precomputation_reducer is 
   x, m, r, q, z: natural;
   vector_r: Digit_Vector;   
begin
loop
  Put("m = "); Get(m);   
  Put("x = "); Get(x);    
------------------------------------------------------------------------------------------------
  r := x;
  loop
     vector_r(0) := r mod 2**k; q := r/2**k;
     for i in 1 .. s-1 loop vector_r(i) := q mod 2**k; q := q/2**k; end loop;
     r := vector_r(0);
     for i in 1 .. s-1 loop r := r + vector_r(i)*b_table(m)(i); end loop;                  
     if r < 2**k then exit; end if;
  end loop;
  if r >= m then z := r-m; else z := r; end if; 
----------------------------------------------------------------------------------------------
  Put(x); Put(" mod "); Put(m); Put(" = "); Put(z); New_Line; New_Line;
end loop;
end precomputation_reducer;





